/**
 * Created by zhanghang on 2015/4/8.
 */
require.config({ 
    baseUrl: CTP.CUIMJsRoot,
    paths: {
		"cordova": "base/cordova",
		"util": "base/cui.util",
		"native": "base/nativeAPI",
		"map": "base/map",
		"tpl": "data/tpl",
		"model": "data/model",
		"testData": "data/testData",
		"core": "data/core",
		"demo": "data/demo",
		"interfaces": "data/interfaces",
		"widgets": "data/widgets",
		"plugins": "data/plugins",
		"icons": "data/icons",
		"scroll": "plugins/cui.scroll",
		"tab": "plugins/cui.tab",
		"chatroom": "plugins/cui.chatroom",
		"list": "plugins/cui.list",
		"approvelist": "plugins/cui.approvallist"
    },
	map: {
		"*": {
			"css": "base/css"
		}
	},
	shim: {
		"util": ["css!" + CTP.CUIMCssRoot +"base/cui.mobile.min.css","css!" + CTP.CUIMCssRoot +"base/cui.mobile.icons.min.css", "css!" + CTP.CUIMCssRoot +"base/cui.mobile.grid.min.css","css!" + CTP.CUIMCssRoot +"plugins/cui.approvallist.css", "css!" + CTP.CUIMCssRoot + "plugins/cui.list.css", "css!" + CTP.CUIMCssRoot +"cuim/index.css"],  
	},
    waitSeconds: 20

});

require(["util", "map", "tpl", "model", "testData", "core", "demo", "interfaces", "widgets", "plugins", "icons", "scroll", "tab", "chatroom", "list", "approvelist"],  function() {
	if (CTP.Util.getDevice().toUpperCase() === "IPHONE") {
		require(["cordova"], function () {
		})
	} 
	
	$('#content').height($(window).height()-50);
	$('#approvePage').height($(window).height()-50);
	(function ($, window, jq, undefined) {
		$.ui.autoLaunch = true; //是否自动启动
	    $.ui.ready(function () {



	 
	 
			/***********************************************************************************************************************
				demo页面
			 ***********************************************************************************************************************/
			//审批流程例子start
			window.demoPageApproveFn = function () { 
				var proOp = {
					id: '222',
					render: 'approive-list-container',
					len: 20, //条数 
					type: 'default',
					isHtmlType: true,
					adapter: function (cb) {
						if (true) {
							var model = TestCTP.testData.model, data = TestCTP.testData.data;
							var editData = {
								tpl: model,
								model: data
							};
							cb(editData);
						}
						if (false) {
							$.getJSON('', function (d) {
								console.log('!!!!!', d);
								var model = d.model, data = d.data;
								console.log(d);
								var editData = {
									tpl: model,
									model: data
								};
								cb(editData);
				
							});
						} 
					}
				};
			 	$.cuiApprovallist(proOp, function () {
					$('.cui-suchivaApprovallist-button').delegate('a', 'click', function () {
						if (!$(this).hasClass('noEvent')) { 
							$('.cui-suchivaApprovallist-button-send').attr('href', '#selectRole');
							var type = $(this).attr('id');
							//var url = 'http://10.10.24.106:8088/web/mobile/approve/defect/send/2c9f8c9c44bfc7330144cf2acea8004e/dde8c1b3-4d8f-45aa-a7e4-b0a964aea175'
							var url = 'http://10.10.24.106:8088/web/mobile/approve/defect/' + type +'/2c9f8c9c44bfc7330144cf2acea8004e/f8494b5c-85ba-41b8-b508-d13c69434d2d';
							$.get(url, function (e) {
								if (e == 1) {
									$.toast(type + '成功');
								} else if (e == 2) {
									$.toast(type + '失败');
								} else if (e == 3) {
									$.toast('此流程服务端之前已经下发了');
								}
					 
							});
							var SData;
							var selectOp = {
								id: '333',
								render: 'selectRoleConinter',
								len: 20, //条数
								type: 'multipleSelect',
								isHtmlType: true, 
								// data: [
								//  {USER_NAME: '埃尔克森', date: 'asdfadf'},
								//  {USER_NAME: '穆里奇', date: 'asdfadf'},
								//  {USER_NAME: '孔卡', date: 'asdfadf'}
								// ],
								dataFields:[
									{left: "55px", top: "13px", dataField : "name", fn: function (p) {
										var text = '<span class="ion-android-contact">姓名：</span>' + p.name;
										return text;
									}},
									{left: "1", top: "13px", dataField : "startDate", fn: function (p) {
										//return '<span class="ion-android-alarm"></span>' + p.startDate;
										return '';
							
									}},
									{left: "1", top: "13px", dataField : "id", type: 'hidden'},
								],
								adapter: function (cb) {
									var conf = {
										pageSize: 16,
										pageNumber: 1
									};
									if ( true ) {
										var d = {
											  "content" : [ {
												    "createDate" : "2015-06-03 17:12:07",
												    "updateDate" : "2015-06-10 16:01:24",
												    "id" : "00014db8b1284400",
												    "name" : "小龙 征婚wtqwtr32q4t2",
												    "des" : "<p>小龙 征婚</p><p><img src=\"/psactivity/ueditor_upload/ccdbb93704da422e8aef3f2410a25f2e/image/20150505/1430818438417055404.jpg\" alt=\"1430818438417055404.jpg\"/>wertwert</p>",
												    "repeatSign" : "1",
												    "startDate" : "2015-06-03 16:25",
												    "endDate" : "2015-08-01 22:00",
												    "cover" : "",
												    "summary" : "小龙 征婚wertwert..."
												  }, {
												    "createDate" : "2015-05-26 16:22:56",
												    "updateDate" : "2015-06-04 17:01:31",
												    "id" : "00014d8f51418e00",
												    "name" : "可重复报名可重复报名可重复报名可重复报名可",
												    "des" : "<p>sdgasdfsadf<br/></p>",
												    "repeatSign" : "1",
												    "cover" : "",
												    "summary" : "sdgasdfsadf..."
												  }, {
												    "createDate" : "2015-04-30 15:20:35",
												    "updateDate" : "2015-05-07 17:16:12",
												    "id" : "00014d0932d37901",
												    "name" : "梧桐山哇",
												    "des" : "<p>爬梧桐山吗？<br/></p><p><img src=\"/psactivity/ueditor_upload/ccdbb93704da422e8aef3f2410a25f2e/image/20150505/1430818438417055404.jpg\" title=\"1430818438417055404.jpg\" alt=\"7209fc8d9a09916710ed4c7a4835ee6b.jpg\"/></p><p>爬！必须爬！爬爬更健康，生活更美好。</p>",
												    "startDate" : "2015-04-10 10:30",
												    "endDate" : "2015-04-30 18:55",
												    "summary" : "爬梧桐山吗？爬！必须爬！爬爬更健康，生活..."
												  }, {
												    "createDate" : "2015-04-29 11:03:50",
												    "updateDate" : "2015-05-28 17:35:03",
												    "id" : "00014d0321663c00",
												    "name" : "新崔斯特姆",
												    "des" : "<p>新崔斯特姆任务：泰瑞尔<br/></p>",
												    "repeatSign" : "0",
												    "startDate" : "2015-05-01 09:00",
												    "endDate" : "2015-05-03 18:00",
												    "cover" : "",
												    "summary" : "新崔斯特姆任务：泰瑞尔..."
												  }, {
												    "createDate" : "2015-04-29 10:39:10",
												    "updateDate" : "2015-06-04 15:57:45",
												    "id" : "00014d030ad1d700",
												    "name" : "卡尔蒂姆",
												    "des" : "<p>卡尔蒂姆任务：黑暗灵魂石</p><p><br/></p><p>佐敦·库勒</p><p><br/></p>",
												    "repeatSign" : "0",
												    "cover" : "",
												    "summary" : "卡尔蒂姆任务：黑暗灵魂石佐敦·库勒..."
												  } ],
												  "size" : 16,
												  "number" : 0,
												  "lastPage" : true,
												  "firstPage" : true,
												  "sort" : [ {
												    "direction" : "DESC",
												    "property" : "createDate",
												    "ignoreCase" : false,
												    "ascending" : false
											  } ],
											  "totalElements" : 5,
											  "numberOfElements" : 5,
											  "totalPages" : 1
										};
										//var d = $.parseJSON(_d);
										var editData = {
											content: d.content,
											size: d.size, //每页条数，即 pageSize
											sort: d.sort,
											lastPage: d.lastPage,
											firstPage: d.lastPage,
											totalElements: d.totalElements,// 总数量
											numberOfElements: d.numberOfElements, // 当前页的数量
											totalPages: d.totalPages,
											next: !(d.firstPage && d.lastPage),
											number: d.number // 当前第几页，从零开始，即 pageNumber - 1
										};
										SData = editData;
										cb(SData);
									}
									if ( false ) {
										$.get('http://10.10.62.122:8087/psactivity/activity/mobile/list', function (_d) {
									
											var d = $.parseJSON(_d);
											var editData = {
												content: d.content,
												size: d.size, //每页条数，即 pageSize
												sort: d.sort,
												lastPage: d.lastPage,
												firstPage: d.lastPage,
												totalElements: d.totalElements,// 总数量
												numberOfElements: d.numberOfElements, // 当前页的数量
												totalPages: d.totalPages,
												next: !(d.firstPage && d.lastPage),
												number: d.number // 当前第几页，从零开始，即 pageNumber - 1
											};
											SData = editData;
											cb(SData);
										}, "json");
									}
								},
								history: function (cb) {
									cb(SData);
								},
								refresh: function (cb) {
									var conf = {
										pageSize: 16,
										pageNumber: 1
									};
									$.get('http://10.10.62.122:8087/psactivity/activity/mobile/list', function (_d) {
										var d = $.parseJSON(_d);
										var editData = {
											content: d.content,
											size: d.size, //每页条数，即 pageSize
											sort: d.sort,
											lastPage: d.lastPage,
											firstPage: d.lastPage,
											totalElements: d.totalElements,// 总数量
											numberOfElements: d.numberOfElements, // 当前页的数量
											totalPages: d.totalPages,
											next: !(d.firstPage && d.lastPage),
											number: d.number // 当前第几页，从零开始，即 pageNumber - 1
										};
										SData = editData;
										cb(SData);
									}, "json");
								}
							};
						 	$.cuiList(selectOp, function (data) {
							 		//请求数据
								if (true) { 
									$('.cui-submit-button').bind('click', function (data) {
										var selected = $('.multipleSelectBg');
										var data = [];
										$.each(selected, function (k, v) {
											data.push($(v).parent('div').attr('data-value'));
										});
										var type = $(this).attr('id');
										var url = 'http://10.10.24.106:8088/web/mobile/approve/defect/' + 'send' +'/2c9f8c9c44bfc7330144cf2acea8004e/88fbf120-1e72-4228-aa78-a7d01c5ef9d9';
										$.post(url, function (e) {
											alert(e);
										});
									
										console.log('data', data);
									});
								}
						 	});
						} else {
							$.toast('该流程不支持此操作！');
						}
			
					});
				});
			};
			demoPageApproveFn();
		
			//审批流程例子end
			/***********************************************************************************************************************
				demo页面 
			 ***********************************************************************************************************************/




			/***********************************************************************************************************************
				底部导航
			 ***********************************************************************************************************************/
			//页面加载
			function setTitle (title) { //设置标题
				var _header1 = $('header').eq(1).attr('id');
				$('#' + _header1).find('h1').text(title);
			}
			function chgPage (arg) { //加载不同的栏目页面
				var methodFn = function (method) { 
					var data = TestCTP[arg +'Data'].FnData[method], html = '';
					if (typeof TestCTP[arg +'Data'].FnData[method] !== 'undefined') {
						jq.each(data, function (k, v) {
							var title = '<h2 class="suchiva-method-details-area-title">' + v.title +'</h2>', content = '<p class="suchiva-method-details-area-content">' + v.content +'</p>'; 
							console.log(title); 
							html += title + content;
						}); 
						html = '<div class="suchiva-method-details-area" id="suchiva-method-details-area-' + arg +'" style=" width: 96%; height: 99%;padding: 0 2%;"><div class="suchiva-method-details-area-container">' + html +'</div></div>';
					} else {
						console.error(method + '不存在！');
					}
					return html; 
				};
				setTimeout(function () {
					var listOp = {
						id: 'testlist',
						render: 'wrap-div',
						len: 20,
						type: 'default',
						dataFields: [{dataField: 'name'}, {dataField: 'name', type: 'hidden'}],
						adapter: function (cb) {				
							var data = {
								content: TestCTP[arg +'Data'].linkTxt,
								size: 20,
								number: 40
							};
							var editData = {
							 			content: data.content,
							 			size: data.size,
							 			number: data.number, 
							 			sort: [],
							 			lastPage: false,
							 			firstPage: false,
							 			totalElements: 4,
							 			numberOfElements: 4,
										totalPages: 1 
							};
							cb(editData);
						}
					};
				 	$.cuiList(listOp, function (e) {
						var $pointer = e;
						$('.cui-suchivaList-ul').delegate('.suchivaList-li-div-name', 'click', function () {
							var _self = $(this), _fn = 'methodFn(_self.text())';
							_self.find('a').attr('href', '#' + arg + 'Page');
							$('#' + arg +'Page').html(eval(_fn));
							setTitle(_self.text()); 
							$.ui.loadContent('#' + arg +'Page', false, false, "slide");
					        new $.iScroll('suchiva-method-details-area-' + arg,
								{
									hscroll: false,
									vscroll: true,
									hScrollbar:false, 
									vScrollbar:true,
									checkDOMChanges: true,  
									onScrollStart: function () {
							

									},
									onScrollMove: function () {
							

									},
									onBeforeScrollEnd: function () {
										
									}, 
									onScrollEnd: function () {
						

									}
								}
							);
				
						});
					});
				}, 0);
			}

			//底部加载方法
			$('#navbar').delegate('a', 'click', function () { 
				//加载页面
				var self = $(this), _id = self.attr('id'), _url = '/cuim/' + _id;
				var _title = $(this).text();
				setTitle(_title);
				$.get(_url, function (tpl) {
					$('#main .wrap-div').html(tpl);
					if (_id !== 'icons') {//页面为icons特别处理
						chgPage(_id);
					} else {
						new $.iScroll('wrap-div',
							{
								hscroll: false,
								vscroll: true,
								hScrollbar:false, 
								vScrollbar:true,
								checkDOMChanges: true
							}
						);
					}
					$.ui.loadContent('#main', false, true, "slide");
					$.ui.hideMask();
					$('body').delegate('.interfaces-button', 'click', function () {
						var _name = $(this).attr('data-role') + 'Fn';
						var _str = $(this).attr('data-str');
						var fn = window[_name]; // runMe
						if (typeof fn === 'function') {
							if (typeof _str !== 'undefined' || _str === '') {
								 fn(_str);
							} else {
								fn();
							}
						}					
					});
	
				
				});
			});
			/***********************************************************************************************************************
				底部导航
			 ***********************************************************************************************************************/
		});	

	})(af, window, jQuery);
});