if(!CTP){
	var CTP = {};
};
CTP.IPHONEAPI = {
	scan : function(cb) { //扫描
        comtop.QRCode.scanCode(cb);
	},
	goPhoto : function(arg) { //拍照
		var _success = arg.success, _fail = arg.fail;
        navigator.camera.getPicture(
				_success, 
				_fail,
				{
					quality: 50, 
					destinationType: 2, 
					sourceType: navigator.camera.PictureSourceType.CAMERA 
				}
		);
	},
	goVideo : function(arg) { //录制视频
		var _success = arg.success, _fail = arg.fail, _highquality = arg.highquality, _frontcamera = arg.frontcamera, _duration = arg.duration;
	    window.plugins.videocaptureplus.captureVideo(
                _success,
                _fail,
                {
                	limit: 1,
                	duration: _duration,
                	highquality: _highquality,
                	frontcamera: _frontcamera
                }
        );
	},
	goRecord : function(arg) {//录音
		var _success = arg.success, _fail = arg.fail;
        comtop.CaptureMedia.captureAudio(_success, _fail, {duration:10}); //10秒限时录音
		
	},
	getLoginInfo : function( arg ) {//登陆信息
		window.location.href="url/portal/eam/getLoginInfo("+arg+")";
	},
	getLocationInfo : function() {
		window.location.href="url/portal/eam/getLocationInfo()";
	},
	getDistance : function( arr ) {
		window.location.href='url/portal/eam/getDistance('+arr+')';
	},
	getInputFieldHeight : function( bottom ){
		window.location.href='url/portal/eam/getInputFieldHeight('+bottom+')';
	},
	openPhoto : function( arg ) { //选择照片
		var _success = arg.success, _fail = arg.fail;
        navigator.camera.getPicture(
				_success, 
				_fail,
				{
					quality: 50, 
					destinationType: 2, 
					sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM 
				}
		);
	},
	openRootPath: function (arg) {
	
	},
	openVideo : function( arg ) { //打开视频
		var _success = arg.success, _fail = arg.fail;
		
		navigator.camera.getPicture(
				_success, 
				_fail, 
				{
					destinationType: navigator.camera.DestinationType.NATIVE_URI,
                    sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM,
                    mediaType: navigator.camera.MediaType.VIDEO 
				}
		);
	}, 
	openRecord : function( src ) { //打开音频
		document.location.href = 'url/portal/eam/openRecord('+src+')';
	},
	bcardScan : function() {
		document.location.href = 'url/portal/eam/bcardScan(capture)';
	},
	openUserDetail : function( type, empID ) {
		document.location.href = 'url/portal/eam/openUserDetail(type='+type+'&emplID='+empID+')';
	},
	goTo : function(projectName){
		document.location.href = 'url/portal/eam/communicate('+projectName+')';
	},
	openDocument : function(docName){ //打开文档！
		document.location.href = 'url/portal/eam/openDocument('+docName+')';
	},
	back : function () {//回退
		var iFrame;
        iFrame = document.createElement("iframe");
        iFrame.setAttribute("src", 'goNative');
        iFrame.setAttribute("style", "display:none;");
        iFrame.setAttribute("height", "0px");
        iFrame.setAttribute("width", "0px");
        iFrame.setAttribute("frameborder", "0");
        document.body.appendChild(iFrame);
        iFrame.parentNode.removeChild(iFrame);
        iFrame = null;
	},
	upLoad : function( arg, name ) { //上传
		var url = arg['url'];
        var postData = arg["data"];
        var path = arg['path'];
		var seviceName = arg["service"];
		var dataFun = postData["dataFun"];
		if( seviceName == undefined ){
			seviceName = "cux_file_import_pkg6";
		}
		if( dataFun == "" || dataFun == undefined ) {
			dataFun = "file_imp";
		}
		var sever = seviceName + "." + dataFun;
        var obj ={
    	    "p_file_name" : "eam_test",
    	    "p_file_type" : postData['file_type'],
    	    "p_entity_type" : postData['func_name'],
    	    "p_entity_id" : postData['bill_id'],
    	    "p_document_id" :  "",
            "p_user_name" : ""
        };
        obj = JSON.stringify(obj);
        var postD = '{"type":"rest", "to" : "EBS", "service":"'+sever+'","data":'+obj+'}';
   		document.location.href = 'test.html?jspAct='+url+'&jsRe='+name+'&multimedia=goUpload&datas='+postD+'&imgPath='+path;
	},
	downLoad : function( arg, name ) { //下载
		var url = arg['url'];
		var fileType = ","+arg["fileType"];
		var postData = arg["data"];
		var seviceName = arg["service"];
		var dataFun = postData["dataFun"];
		if( seviceName == undefined ){
			seviceName = "cux_file_import_pkg6";
		}
		if( dataFun == "" || dataFun == undefined ) {
			dataFun = "file_get";
		}
		var sever = seviceName + "." + dataFun;
		var obj = {
			"p_document_id" : postData["id"]
		};
		var id = postData["id"] + fileType;
		var pd = JSON.stringify(obj);
		var postD = '{"type":"rest", "to" : "EBS", "service":"'+sever+'","data":'+pd+'}';
		document.location.href = 'test.html?jspAct='+url+'&jsRe='+name+'&multimedia=goDownload&datas='+postD+'&imgPath='+id;
	},
	deleteAttach : function( arg ) {
		
	},
	handleData : function ( arg ) {
		var dtype = arg["dtype"],
			ftype = arg["ftype"],
			postData = arg["data"],
			callback = arg["cb"],
			seviceName = arg["service"];
			
		if( seviceName == undefined ) {
    		seviceName = "cux_eam_api_pkg13";
    	}
		var service = seviceName + "." + postData["dataFun"],
			type = arg["type"],
			to = arg["to"], url = arg["url"];
		
	    var name = "jsonp_" + CTP.Util.now() + '_' + CTP.Util.rand();
	    if( dtype == "file" ){
	    	if(ftype == "upLoad"){
	    		this.upLoad( arg, name );
	    	}else{
	    		this.downLoad( arg, name );
	    	}
	    }else{
	    	postData.dataFun = undefined;
	    	var obj = {
    			type : type,
    			to : to,
    			service : service,
    			data : postData
    		};
	    	pd = JSON.stringify(obj);
	    	document.location.href = 'test.html?jspAct='+url+'&jsRe='+name+'&multimedia=0&datas='+pd+'';
	    }
	    window[name] = function( json ) {
	    	var retData = JSON.parse( json );
	        window[name] = undefined;
	        callback(retData);
	    };
	},
	cloundVol : function() {
		document.location.href = 'url/portal/eam/cloundVol()';
	}
};