if(!CTP){
	var CTP = {};
};
(function() {
	var $pointer = null,
		nativaCbobj = {},
		NativeAPI = null,
		Native = {},
		dataInst = null,
		type = CTP.Util.getDevice().toUpperCase();
	if ( false &&type === 'IPHONE') {
		var _url = '../cuim/javascripts/base/cordova.js', _script = document.createElement('script');	
		_script.type = "text/javascript";
		_script.src = _url;
		document.getElementsByTagName('head')[0].appendChild(_script); 
	}
	CTP.NativeCb = {
		setLoginInfo : function( o ) {
			o = JSON.parse( o );
//			window.localStorage.setItem("loginName", o.loginName);
			CTP.Publisher.publish("getLoginFinish",  o, $pointer);
		},
		setLocationInfo : function( o ) {
			window.localStorage.setItem("location", o);
			nativaCbobj = JSON.parse(o);
			CTP.Publisher.publish("getLocationFinish",  nativaCbobj, $pointer);
		},
		/**
		* 二维码扫描完成 回调函数
		* qcode  返回扫描结果
		*/
		openQcodeFinish : function( qcode ){
			//alert(qcode);
			qcode = JSON.parse(qcode);
			nativaCbobj = qcode;
			CTP.Publisher.publish("scanFinished", nativaCbobj, $pointer);
		},
		/**
		  *拍照完成 回调函数
		  *fileName 拍照完成的返回的文件名称
		  *fileData 暂未处理
		  *返回小图标 
		*/
		photoFinish : function ( filePath, fileData, fileName ){
			nativaCbobj = {
				filePath : filePath,
				fileData : fileData,
				fileName : fileName,
				type : "image/pjpeg"
			};
			CTP.Publisher.publish("attachFinish", nativaCbobj, $pointer);
		},
		/**
		  * 视频完成
		  *fileName 视频完成的返回的文件名称
		  *fileData 暂未处理
		  *路径中openVideo()为播放视频标示在后面直接加文件名称进行视频播放
		  *返回小图标 -- 需要处理 64 * 64
		*/
		videoFinish : function( filePath, fileType, fileData, fileName ) {
			nativaCbobj = {
				filePath : filePath,
				fileData : fileData,
				fileName : fileName,
				type : "video/quicktime"
			};
			CTP.Publisher.publish("attachFinish", nativaCbobj, $pointer);
		},
		/**
		  *录音完成
		  *fileName 录音完成的返回的文件名称
		  *fileData 暂未处理
		  *路径中openRecord()为播放录音标示在后面直接加文件名称进行录音播放
		*/
		recordFinish : function( filePath, fileData, fileName ) {
			nativaCbobj = {
				filePath : filePath,
				fileData : fileData,
				fileName : fileName,
				type : "application/octet-stream"
			};
			CTP.Publisher.publish("attachFinish", nativaCbobj, $pointer);
		},
		downLoadFinish : function( filePath, fileType, fileData, fileName ) {
			nativaCbobj = {
				filePath : filePath,
				fileData : fileData,
				fileName : fileName,
				type : fileType
			};
			CTP.Publisher.publish("downLoadFinish", nativaCbobj, $pointer);
		},
		cloundVolFinish : function( volString ) {
			nativaCbobj = volString;
			CTP.Publisher.publish("cloundVolFinish", nativaCbobj, $pointer);
		},
		setDistanceFinish : function( arg ) {
			nativaCbobj = JSON.parse(arg);
			CTP.Publisher.publish("distanceFinish", nativaCbobj, $pointer);
		},
		scanResult : function( bcardInfo ) {
			/*
			 * {
			"name":"刘正伟",
			"mobile":"13418901085",
			"company":"深圳盈诺德信息技术有限公司",
			"duty":"资深顾问",
			"address","深圳市南山区联想大夏12楼东侧",
			"tel":"075523982505",
			"email":"liuzhengwei@kingnode.com",
			"site":"www.kingnode.com",
			"fax":"075523980473",
			"dept":"研发部"
			}
			*/
			nativaCbobj = JSON.parse(bcardInfo);
			CTP.Publisher.publish("bcardScanFinish", nativaCbobj, $pointer);
		}
	};
	var apiType = type+"API";
	NativeAPI = CTP[apiType];
	Native.API = {
		setDataControl : function( dataControl ) {
			dataInst = dataControl;
		},
		goPhoto : function( arg ) {
			$pointer = arg;
			NativeAPI.goPhoto(arg);
		},
		goVideo : function( arg ) {
			$pointer = arg;
			NativeAPI.goVideo(arg);
		},
		goRecord : function( arg ) {
			$pointer = arg;
			NativeAPI.goRecord(arg);
		},
		setVisible: function (arg) {
			NativeAPI.setVisible(arg);
		},
		getLoginInfo : function( arg, param ) {
			$pointer = arg;
			NativeAPI.getLoginInfo(param);
		},
		scan : function ( cb ) {
			NativeAPI.scan(cb);
		},
		back : function() {
			NativeAPI.back();
		},
		refresh : function () {
			NativeAPI.refresh();
		},
		handleData : function( arg ) {
			if( dataInst != null ) {
				dataInst.handleData( arg );
			}else{
				NativeAPI.handleData( arg );
			}
		},
		getLocationInfo : function( arg ) {
			$pointer = arg;
			NativeAPI.getLocationInfo();
		},
		getDistance : function( arg, arr ) {
			$pointer = arg;
			var s = JSON.stringify(arr);
			NativeAPI.getDistance( s );
		},
		getInputFieldHeight : function(bottom){
			NativeAPI.getInputFieldHeight( bottom );
		},
		openPhoto : function( arg ) {
			NativeAPI.openPhoto(arg); 
		},
		openVideo : function( arg ) {
			NativeAPI.openVideo(arg);
		},
		openRecord : function( src ) {
			NativeAPI.openRecord(src);
		},
		bcardScan : function( arg ) {
			$pointer = arg;
			NativeAPI.bcardScan();
		},
		setCtpTime : function() {
			
		},
		openUserDetail : function( type, empID ) {
			NativeAPI.openUserDetail( type, empID );
		},
		goTo : function(arg) {
			NativeAPI.goTo(arg);
		},
		openDocument : function(arg) {
			NativeAPI.openDocument(arg);
		},
		openRootPath: function (arg) {
			NativeAPI.openRootPath(arg);
		}
	};
	CTP.NativeAPI = Native.API;
}());