/**
 * Created with JetBrains WebStorm.
 * User: chenxuming
 * Date: 14-5-23
 * Time: 下午2:49
 * To change this template use File | Settings | File Templates.
 */

(function($){
    $.fn.dropdownMenu =function(op){
        var dropDown =function(opt,el){
            var optr ={
                data:[],
                el:el,
                position:"bottom-right",
                onSelect:function(){}
            };
            this.opt = $.extend(optr,opt);


            this.init();

        };
        dropDown.prototype.init =function(){
            this.data= JSON.parse(JSON.stringify(this.opt.data));
            this._buildHtml();
            this._bindEvent();
            $("#"+this._id).data("isshow","false");
        };
        dropDown.prototype._buildHtml =function(){
            var opt =this.opt;
            var id =(9*Math.random()+1).toString().replace(".","");
            var html=['<ul id="',id,'" class="dropdown-menu">'];
            $.each(this.data,function(index,val){
                var at ="";  val._id_ =(9*Math.random()+1).toString().replace(".","");
                if(val.ignore){
                    at = 'data-ignore="true"';
                }
                html.push('<li><a id="',val._id_,'" ',at,' href="',val.href||"#",'">',val.name||"",'</a></li>');
            });
            html.push('</ul>');
            this._id =id;
            $(document.getElementById("afui")).append(html.join(''));

        };
        dropDown.prototype._getDataById =function(id){
            var da = this.data,res=null;
             for(var i= 0,len=da.length;i<len;i++){
                 if(da[i]._id_===id){
                     res=da[i];
                     break;
                 }
             }
             return res;
        };
        dropDown.prototype.show =function(){
            var container =$("#"+this._id);
            container.show();
            container.data("isshow","true");
        };
        dropDown.prototype.hide =function(){
             var container =$("#"+this._id);
                 container.hide();
                 container.data("isshow","false");
        };
        dropDown.prototype._bindEvent =function(){
            var el =this.opt.el,container =$("#"+this._id);

            var po =this.opt.position,self=this;
            $(el).on("click",function(e){
                var rect =this.getBoundingClientRect(),
                    right =window.innerWidth-rect.right<0?3:window.innerWidth-rect.right+3;
                container.css({
                    top:po.indexOf("bottom")!==-1?rect.bottom+5:"",
                    left:po.indexOf("left")!==-1?rect.left:"",
                    right:po.indexOf("right")!==-1?right:""
                });
                if(container.data("isshow")==="false"){
                    self.show();
                }else{
                    self.hide();
                }
                e.stopPropagation();
                e.preventDefault(); // 避免a跳转
            });
            container.on("click",function(e){
                 var target = $(e.target),id=target.attr("id");
                 var res = self.opt.onSelect.call(self,self._getDataById(id));
                if(res ===false){
                    e.stopPropagation();
                }
            });

            if(!$(document.body).data("dropdown-event-bind")){
                $(document.body).on("click",function(){
                   $(".dropdown-menu").hide().data("isshow","false");
                });
                $(document.body).data("dropdown-event-bind",true);
            }

        };

        var tem;
        this.each(function(){
            tem =  new dropDown(op,this);
        });

        return this.length===1?tem:this;
    }
})(window.af);