/**
 * Created with JetBrains WebStorm.
 * Author : chenxuming
 * Contact: chenxuming@szcomtop.com
 * Date:    14-8-20
 * Time:    下午2:31
 * To change this template use File | Settings | File Templates.
 */
(function($){
     var win =window,doc=document;
    function From($context){
        this.$el =$context =$context ||$(doc.body);
        this.$formEl=this.$el.find("input,textarea");
        this.validate = $.validate();
        this._init();
    };
    From.prototype ={
       _init:function(){
           var self =this;
           this.$formEl.each(function(){
               var validate =this.getAttribute("validate"),rules;
               if(validate){
                   if(win[validate]){
                       rules = win[validate];
                   }else{
                       try{
                           rules = win.JSON.parse(validate);
                       }catch(e){
                           rules ={type:"required",msg:validate};
                       }
                   }
                 if(rules){
                     self.validate.addRule(this,rules);
                 }

               }
           });
          this._bindEvent();
       },
     _bindEvent:function(){
         var self =this;
         this.$formEl.on("change",function(){
             self.doValidate(this.id);
         });
     },
      setValue:function(obj){




      },
      getValue:function(){
          var res ={};
          this.$formEl.each(function(){
              res[this.id] =this.value;
          });
         return res;

      },
      doValidate:function(id){

         var res = this.validate.doValidate(id);
          if(res===true){
              this.validSuccess(id);
          }else{
              this.validFail(res);
          }
          return res;

      },
      empty:function(){
          this.$formEl.removeClass("cui-validate-error").each(function(){
              this.value="";
              $("#"+this.id+"-label").html("");
          });
      },
        validFail: function (obj) {

            $("#"+obj.id).addClass("cui-validate-error");

            $("#"+obj.id+"-label").html(obj.msg);


            return this;
        },

        /**
         * 验证成功
         */
        validSuccess: function (id) {
            if(id){
                $("#"+id).removeClass("cui-validate-error");

                $("#"+id+"-label").html("");
            }else{
                this.$formEl.removeClass("cui-validate-error");
            }
            return this;
        }
    };
    $.form = $.component.form = function(selector){
        var context,type= $.type(selector);
        if(type==="string"){
            context =$(selector);
        } else if(type==="object"){
            context = selector.container;
        }

        return new From(context);
    }
})(window.af);