/**
	Progress
 */
'use strict';
(function ($, window, undefined) {

	var createHtml = function (op) {
		var id = op.id;
		var html = '<div class="cui-progress-bar" id="' + id + '" style="height: 1px;background: red;"></div>';
		return html;
	};
	var Progress = function () {
		this.init.apply(this, arguments);
	};
	Progress.prototype = {
		constructor: Progress,
		init: function () {
			var args = Array.prototype.slice.call(arguments)[0];
			this.setOptions(args);
		},
		setOptions: function (args) {
			var self = this;
			var op = args[0];
			var cb = args[1];
			var defaultOp = {
				
			};
			this.options = op;
			this.render(cb);
			
		},
		render: function (cb) {
			var op = this.options,
				renderTarget = op.render,
				id = op.id,
				html = createHtml(op);
			var self = this;
			$('#' + renderTarget).append(html);
			if (typeof cb === 'function') {
				cb(self.animation, op);
				
			}
		},
		animation: function (op) {
			var id = op.id;
			$('#' + id).addClass('slideleftin');
			
			setTimeout(function () {
				$('#' + id).removeClass('slideleftin');
				$('#' + id).addClass('sliderightout'); 
				setTimeout(function () {
					$('#' + id).hide();
				}, 400);
			}, 1000);
		}
	};
	
	var progress = function () {
		return new Progress(arguments);  
	};
	$.progress = progress;    
})(af, window);