'use strict';
(function ($, window, undefined) {

	function loaded(r){
        var myscroll = new iScroll(r,
			{
				hscroll: true,
				vscroll: false,
				hScrollbar:true, 
				vScrollbar:false
			}
		);
	}
	var createHtml = function (data, op) {
		var id = op.id;
		var html = '<div class="cui-timeline-container" id="' + id + '"><div class="cui-timeline-container-line"></div>';
		var width = $(window).width() - 60;
		$.each(data, function (k, v) {
			var item = '<div class="cui-timeline-item"><div class="cui-timeline-item-l" ><span></span></div><div class="cui-timeline-item-r" style="width: ' + width + 'px;"><p>' + v.text+'</p><p>' + v.date +'</p></div></div>';
			html += item;
		});
				
		return html;
	};
	var Timeline = function () {
		this.init.apply(this, arguments);
	};
	Timeline.prototype = {
		constructor: Timeline,
		init: function () {
			var args = Array.prototype.slice.apply(arguments)[0];
			var op = args[0]; 
			this.setData(op);
			
		},
		render: function (data, op) {
			var self = this;
			var renderTarget = op.render;
			var html = createHtml(self.data, op); 
			$('#' + renderTarget).html(html);
			self.loadScroll(op);
		},
		setData: function (op) {
			if (typeof op.adapter !== 'undefined') {
				this.data = op.adapter();
			} else {
				this.data = op.data; 
			}
			this.render(this.data, op);
		},
		loadScroll: function (op) {
			var renderTarget = op.render;
			loaded(renderTarget);
		}
	};


	var timeline = function () {
		return new Timeline(arguments);
	}; 
	$.timeline = timeline;
})(af, window);