/**
	测试
 */
'use strict';
if (typeof TestCTP === 'undefined') {
	var TestCTP = {};
}

(function () {
	var testData = {
	"model" : {
		"unvisable" : {
			"processCode" : "defectWorkFlow",
			"processIdPropertName" : "processId",
			"workIdPropertName" : "id"
		},
		"visible" : {
			"button" : [{
					"id" : "submit",
					"label" : "上报"
				}, {
					"id" : "send",
					"label" : "发送"
				}, {
					"id" : "return",
					"label" : "回退"
				}, {
					"id" : "back",
					"label" : "撤回"
				}
			],
			"group" : [{
					"properties" : [{
							"bindAttr" : "DefectCoreDTO.defectSourceDescr",
							"className" : "DefectCoreDTO",
							"id" : "defectSourceDescr",
							"label" : "缺陷来源",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.findUserUname",
							"className" : "DefectCoreDTO",
							"id" : "findUserUname",
							"label" : "发现人",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.findDeptOname",
							"className" : "DefectCoreDTO",
							"id" : "findDeptOname",
							"label" : "发现班组",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.findTime",
							"className" : "DefectCoreDTO",
							"id" : "findTime",
							"label" : "发现时间",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.dealTimeLimit",
							"className" : "DefectCoreDTO",
							"id" : "dealTimeLimit",
							"label" : "消缺期限",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.feederName",
							"className" : "DefectCoreDTO",
							"id" : "feederName",
							"label" : "线路",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.deviceName",
							"className" : "DefectCoreDTO",
							"id" : "deviceName",
							"label" : "缺陷设备名称",
							"type" : "text"
						}, {
							"bindAttr" : "WorkflowDTO.code",
							"className" : "WorkflowDTO",
							"id" : "code",
							"label" : "编码",
							"type" : "text"
						}
					],
					"title" : "基本信息"
				}, {
					"properties" : [{
							"bindAttr" : "DefectCoreDTO.assetDTO.installationLocation",
							"className" : "AssetDTO",
							"id" : "installationLocation",
							"label" : "安装地点",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.defectDescr",
							"className" : "DefectCoreDTO",
							"id" : "defectDescr",
							"label" : "缺陷描述",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.remark",
							"className" : "DefectCoreDTO",
							"id" : "remark",
							"label" : "备注",
							"type" : "text"
						}, {
							"bindAttr" : "DefectCoreDTO.defectLevelDescr",
							"className" : "DefectCoreDTO",
							"id" : "defectLevelDescr",
							"label" : "缺陷等级",
							"type" : "text"
						}, {
							"bindAttr" : "DefectStandardLibDTO.defectPhenomenon",
							"className" : "DefectStandardLibDTO",
							"id" : "defectPhenomenon",
							"label" : "缺陷表象",
							"type" : "text"
						}, {
							"bindAttr" : "DefectStandardLibDTO.suggestMeasure",
							"className" : "DefectStandardLibDTO",
							"id" : "suggestMeasure",
							"label" : "建议处理措施",
							"type" : "text"
						}, {
							"bindAttr" : "DefectStandardLibDTO.defectDeviceTypeDTO.deviceType",
							"className" : "DefectDeviceTypeDTO",
							"id" : "deviceType",
							"label" : "设备类型",
							"type" : "text"
						}, {
							"bindAttr" : "DefectStandardLibDTO.defectPositionDTO.defectPosition",
							"className" : "DefectPositionDTO",
							"id" : "defectPosition",
							"label" : "缺陷部位",
							"type" : "text"
						}, {
							"bindAttr" : "DefectStandardLibDTO.defectTypeDTO.defectType",
							"className" : "DefectTypeDTO",
							"id" : "defectType",
							"label" : "缺陷类别",
							"type" : "text"
						}
					],
					"title" : "缺陷信息"
				}, {
					"properties" : [{
							"bindAttr" : "CommentsVO.comments",
							"className" : "CommentsVO",
							"id" : "comments",
							"label" : "流程信息",
							"properties" : [{
									"className" : "WorkFlowNode",
									"id" : "curNodeName",
									"label" : "当前节点名称",
									"type" : "text"
								}, {
									"className" : "WorkFlowNode",
									"id" : "actorName",
									"label" : "处理人",
									"type" : "text"
								}, {
									"className" : "WorkFlowNode",
									"id" : "opinion",
									"label" : "审批意见",
									"type" : "text"
								}, {
									"className" : "WorkFlowNode",
									"id" : "overTime",
									"label" : "审批时间",
									"type" : "text"
								}
							],
							"type" : "list"
						}
					],
					"title" : "流程信息"
				}
			]
		}
	},
	"data" : {
		"DefectCoreDTO.id" : "159b11a5-e9dd-441f-84c3-6c34ee46a8f0",
		"DefectCoreDTO.defectSourceDescr" : "巡视",
		"DefectCoreDTO.findUserUname" : "范伟平",
		"DefectCoreDTO.findDeptOname" : "龙岗供电局/配电一部/巡维二班",
		"DefectCoreDTO.findTime" : "2014-08-21 08:55:00",
		"DefectCoreDTO.dealTimeLimit" : "2014-08-28 08:55:00",
		"DefectCoreDTO.deviceName" : "池屋开关",
		"WorkflowDTO.code" : "QX033020140821-004",
		"DefectStandardLibDTO.defectPhenomenon" : "",
		"DefectStandardLibDTO.suggestMeasure" : "",
		"DefectStandardLibDTO.defectDeviceTypeDTO.deviceType" : "",
		"DefectStandardLibDTO.defectPositionDTO.defectPosition" : "",
		"DefectStandardLibDTO.defectTypeDTO.defectType" : "",
		"DefectCoreDTO.defectLevelDescr" : "重大",
		"DefectCoreDTO.defectDescr" : "热点温度≥80℃或相对温差≥80％",
		"DefectCoreDTO.assetDTO.installationLocation" : "",
		"CommentsVO.comments" : [{
				"overTime" : "2014-08-21 08:58:22",
				"curNodeName" : "登记缺陷",
				"opinion" : null,
				"actorName" : "范伟平"
			}, {
				"overTime" : "2014-08-21 11:50:42",
				"curNodeName" : "班长审批",
				"opinion" : "请协调处理",
				"actorName" : "曾繁雄"
			}, {
				"overTime" : "2014-08-22 15:38:14",
				"curNodeName" : "设备管理专责",
				"opinion" : null,
				"actorName" : "李刚"
			}, {
				"overTime" : "2014-08-22 15:38:14",
				"curNodeName" : "主任审核",
				"opinion" : null,
				"actorName" : "欧阳健"
			}
		],
		"button" : [{
				"id" : "send",
				"users" : []
			}, {
				"id" : "back",
				"users" : []
			}
		]
	}
}
;
	TestCTP.testData = testData;
})();
