/**
 * Created by zhengzhong on 2015/5/7.
 * 页面模板模型定义
 */
if (typeof TestCTP === 'undefined') {
	var TestCTP = {};
}
(function () {
	var tpl = {
	    unvisable:{
	        //流程编号
	        processCode:'defectWorkFlow',
	        //流程ID对应的模型属性名
	        processIdPropertName:'processId',
	        //工单ID对应的属性名
	        workIdPropertName:'defectId'
	    },
	    visible:{
	        group:[
	          {
	            title:'缺陷基本信息',
	            properties:[
	                {
	                    id:'processInsId',
	                    label:'缺陷ID',
	                    type:'text'
	                },
	                {
	                    id:'findUserUname',
	                    label:'用户名',
	                    type:'text'
	                },
	                {
	                    id:'dealMeasure', 
	                    label:'设备名称',
	                    type:'link',
	                    url:'http://10.10.5.55/web/fwms/defect.do?id={{device.deviceId}}'
	                }
	            ]
	          },
	          {
	            title:'缺陷基本信息',
	            properties:[               
	                {
	                    id:'comments',
	                    label:'流程意见',
	                    type:'list',
	                    properties: [
	                        {
	                            id:'user',
	                            label:'处理人',
	                            type:'text'
	                        },
	                        {
	                            id:'comment',
	                            label:'意见',
	                            type:'text'
	                        }
	                    ]
	                }
	            ]
	          }
	        ],
	        button:[
	            {
	                id:'send',
	                label:'发送'
	            },
	            {
	                id:'back',
	                label:'回退'
	            }
	        ]
	    }
	};
	
	TestCTP.tpl = tpl;
	
})();
