/**
 * Created with JetBrains WebStorm.
 * User: chenxuming
 * Date: 14-6-10
 * Time: 下午2:40
 * To change this template use File | Settings | File Templates.
 */
(function($){

  var popLayer =function(op){
    var opt = {
         onClose:function(){},
         height:50,
         needBlockUI:true,
         clickMaskHide:true,
         opacity:0.1,
         time:"230ms",
         bgColor:"#fff",
         html:''
     };
    $.extend(opt,op);
    this.opt = opt;
    this.init();
  };
  popLayer.prototype.init=function(){
      var op =this.opt,self =this;
      this.container = $(document.createElement("div")).css({
          "position":"fixed",
          "z-index":99999,
          "-webkit-transition":"height 230ms ease-in-out",
          "transition":"height 230ms ease-in-out",
          "width":"100%",
          "background-color":op.bgColor,
          "left":0,
          "right":0,
          "bottom":0,
          "height":0
      });
      if(typeof op.html==="string"){
          this.container.html(this.opt.html);
      }else if(typeof op.html ==="object"){
           $(op.html).show();
          this.container.append(op.html);
      }
      $(document.getElementById("afui")).append(this.container);

  };
  popLayer.prototype.show=function(){
      var self = this;
      this.container.height(this.opt.height);

      if(this.opt.needBlockUI){
        var maskDiv = $.ui.blockUI(this.opt.opacity);
          if(this.opt.clickMaskHide){
              maskDiv.on("touchstart mousedown",function(e){
                  e.preventDefault();
                  e.stopPropagation();
                  self.hide();
              });
          }
      }
      this.isShow=true;
  };
  popLayer.prototype.hide = function(){
    //  this.container.css({"transform":"translate3d(0,0,0)","-webkit-transform":"translate3d(0,0,0)"});
      var self =this;
      this.container.height(0);
/*      .css3Animate({y:"100%",time:this.opt.time,complete:function(){
           self.container.height(0);
      }});*/
      this.isShow = false;
      this.opt.onClose.call(this,this);
      if(this.opt.needBlockUI){
          $.ui.unblockUI();
      }
  };

    popLayer.prototype.setHeight = function(h){
        this.opt.height = h;
        if(this.isShow){
            this.container.css({"height":h});
        }
    };

  $.popLayer = function(opt){

      return new popLayer(opt);

  };

})(window.af);