/**
 * cuiApprovallist 审批流程详情列表
 * @author suchiva@126.com
 * @version 2015-05-19
 * @requires jquery, af
 */

'use strict';
(function ($, jq, window, undefined) {
	var startTime = 0, winW =  document.documentElement.clientWidth || document.body.clientWidth, DATACOUNTER = [];
	
	var createHtml = function (d, op, type, additions) {
		var id = op.id,
			data = d.model,
			button = data.button,
			tpl = d.tpl,
			unvisable = tpl.unvisable,
			visible = tpl.visible,
			group = visible.group,
			buttonList = '',
			liType = type || 'default',
			html = '<div class="innerContainer" style="padding-bottom: 50px;" id="' + id +'" data-code="' + data[unvisable['processCode']]+'" data-processIdPropertName="' + data[unvisable['processIdPropertName']]+'" data-workIdPropertName="' + data[unvisable['workIdPropertName']] +'"><div class="cui-suchivaApprovallist"><ul class="cui-suchivaApprovallist-ul">',
			width = $(window).width() - 60,
			boolenHtmlType = op.isHtmlType || false, //是否支持HTML字符
			lidom = addLi(data, group, op);
			
			//console.log('model', d.model);
			//console.log('tpl', d.tpl);
		if (data) {
			html += lidom;
			html += '</ul></div></div>';
 
		} else {
			html += '</ul><div class="cui-suchivaApprovallist-noData">没有数据！</div></div></div>'	
		}
		if (typeof visible.button !== 'undefined') { 
			var newAry = []
			$.each(visible.button, function (k, v) {
				var itemButton = '', itemButtonDisable;
				newAry.push(v);
				$.each(button, function (m, n) {
					if (v.id === n.id) {
						newAry.pop(n);
						itemButton = '<a href="javascript:void(0);" id="' + v.id +'" style="width: '+ (100/ visible.button.length)+'%;" class="cui-suchivaApprovallist-button-' + v.id +'" data-role="' + v.users +'" data-users="' + n.users +'"><span>' + v.label +'</span></a>';
					}
					
				});
				//itemButton = '<a href="javascript:void(0);" style="width: '+ (100/ visible.button.length)+'%;" class="cui-suchivaApprovallist-button-' + visible.button[i].id +'" data-role="' + visible.button[i].users +'"><span>' + visible.button[i].label +'</span></a>';
				buttonList += itemButton;
				
			});
			$.each(newAry, function (k, v) {
				var itemButton;
				itemButton = '<a href="javascript:void(0);" data-ignore="true" id="' + v.id +'" style="width: '+ (100/ visible.button.length)+'%;" class="cui-suchivaApprovallist-button-' + v.id +' noEvent" data-role="' + v.users +'"><span>' + v.label +'</span></a>';
				buttonList += itemButton;
				
			});
			html += '<div class="cui-suchivaApprovallist-button">' + buttonList +'</div>';
		}
		return html; 
	};

	var addHtml = function (data,group, op) {
			var html = '',
				lidom = addLi(data, group, op);
			html = lidom;
			return html;

	};

	var addLi = function (data, group, op) {
		var html = '';
		var singleDataField = ''; 
		$.each(group, function (k, v) {
			var title = '<h2 class="cui-suchivaApprovallist-li-title ">' + v.title +'<span style="float: right;margin-right: 5px;"></span></h2>';
			singleDataField += '<li>' + title + '<div class="cui-suchivaApprovallist-li-main">' + itemFactory.init(data, v.properties, op) + '</div></li>';
		});
		html += singleDataField;
		return html; 
	};
	var setLiWidth = function () {
		$.each($('.cui-chatApprovallist-item-r'), function (v, k) {
			$(k)[0].style.width = winW - 29 + 'px';  
		});
	};

	var itemFactory = {
		setData : function (data, op) {
			self.data = data;
		},
		getData : function () {
			return self.data;
		}, 
		init: function (data, datafield, op) {
			var self = this, data = data, op = op, html = '';
			self.setData(data);
			$.each(datafield, function (k, v) {
				var type = v.type;
				html += self.types[type](self.getData(), v);
			})
			return html;
		}

	};
	
	itemFactory.types = {
		default : function (pointer, boolenHtmlType, additions) {
			var self = pointer, _index, html = '';
			
			if (self.store.length > 0) {
				if (additions === 'history') { 
					_index = DATACOUNTER.length - self.store.length ;
					$.each(self.store, function (k, v) {
						var item = '<li><h2 class="cui-approvallist-li-date" style="top:' + ((_index + k)*235)+'px;">' + v['date'] +'</h2><h2 class="cui-approvallist-li-dateBake">ssss</h2><dl class="cui-approvallist-dl-agree-' +v['agree']+'"><div class="cui-approvallist-approvallist-dl-mainArea"><p><label>' + v['userName'] +'</label><span>(14:01)</span></p><p><label>耗时：</label><span>' +v['spendTime']+ '</span></p><p><label>意见：</label><span>' + v['comments'] +'</span></p></div></dl></li>';
						html += item;
					});
					return html; 
				} else {
					_index = 0;
					DATACOUNTER = self.store;
					$.each(self.store, function (k, v) {
						var item = '<li><h2 class="cui-approvallist-li-date" style="top:' + ((k)*235)+'px;">' + v['date'] +'</h2><h2 class="cui-approvallist-li-dateBake">ssss</h2><dl class="cui-approvallist-dl-agree-' +v['agree']+'"><div class="cui-approvallist-approvallist-dl-mainArea"><p><label>' + v['userName'] +'</label><span>(14:01)</span></p><p><label>耗时：</label><span>' +v['spendTime']+ '</span></p><p><label>意见：</label><span>' + v['comments'] +'</span></p></div></dl></li>';
						html += item;
					});
					return html; 
				}
				
			} 
		}, 
		text: function (data, datafield) { 
			var html = '';
			
			if (typeof data[datafield.bindAttr] === 'undefined') {
				console.error('数据没有相关的字段');
				html = '<p><label>' +  datafield.label +'</label><span class="' + datafield.className +'" data-attr="' + data[datafield.bindAttr] +'"></span></p>'
			} else {
				html = '<p><label>' +  datafield.label +'</label><span id="' + datafield.id  + '" class="' + datafield.className +'" data-attr="' + data[datafield.bindAttr] +'">' + data[datafield.bindAttr] +'</span></p>'
			}
			
			return html;
		},
		link: function (data, datafield) {
			var html = '';
			if (typeof data[datafield.id] === 'undefined') {
				console.error('数据没有相关的字段');
				html = '<p><label>' +  datafield.label +'</label><span></span></p>'
			} else {
				html = '<p><label>' +  datafield.label +'</label><span><a href="' + datafield.url + '" data-ignore="True">' + data[datafield.id] +'</a></span></p>'
			}
			
			return html;
		}, 
		list: function (data, datafield) {
			var html = '', listComments = '';
			console.log(datafield.bindAttr);
			if (typeof data[datafield.bindAttr] === 'undefined') {
				console.error('获得的数据没有' + datafield.id +'这个字段');
				html = '<p><label>' +  datafield.label +'</label><span></span></p>'
			} else {
				if (data[datafield.bindAttr].length > 0) {
					$.each(data[datafield.bindAttr], function (k, v) {
						listComments += '<label>' +v.actorName+'</label><span><b>意见：</b>' +v.opinion+'</span><span><b>耗时：</b>' +v.overTime+'</span>'
					});
				} else { //没有意见
			
				} 
				html = '<p><label style="font-size: 17px; ">' +  datafield.label +'</label>' + listComments +'</p>'
			}
			
			return html;
		}
	};


	var ApprovalList = function () {
		this.init.apply(this, arguments);
	};
	ApprovalList.prototype = {
		constructor: ApprovalList,
		init: function () {
			var args = Array.prototype.slice.apply(arguments)[0];
			var op = args[0],
				cb = args[1];
			this.options = op;
			this.cb = cb;
			this.setData(op);
			self.selectData = 0; 
		},
		render: function (data, op) {
			
			var self = this,
				renderTarget = op.render,
				type = op.type;
			var html = createHtml(data, op, type, 'new'); 
			$('#' + renderTarget).html(html);
			this.setLiWidth();
			self.loadScroll(op);
			self.toggleItem();
			if (typeof self.cb === 'function') {
				self.cb(); 
			}
			
		    
		},
		addItem: function (data, cb) { 
			var self = this,
				op = this.options,
				id = op.id,
				renderTarget = op.render,
				type = op.type,
				html = createHtml(data, op, type, 'new'); 
			$('#' + renderTarget).html(html);
			this.setLiWidth();
			var tempStr = '总计' + $('#' + id).find('.cui-chatApprovallist').children('li').length + '条评论';
			$('#' + id).find('.total-comments').html(tempStr);
			if (typeof cb === 'function') {
				cb();
			}

		},
		toggleItem: function () {
			$('body').delegate('.cui-suchivaApprovallist-li-title', 'click', function () {
				$(this).parent('li').find('h2 span').toggleClass('ion-chevron-down');
				$(this).parent('li').toggleClass('paddingBottom').find('.cui-suchivaApprovallist-li-main').toggle();
			});
		},
		setLiWidth: function () {
			setLiWidth(); 
		},
		setData: function (op) {
			var self = this;
			if (typeof op.data !== 'undefined') {
				self.data = op.data;
				self.render(self.data, op);
			} else if (typeof op.adapter !== 'undefined') {
				self.data = {};
				op.adapter(function (d) {
					self.render(d, op);	
					self.data = d;
				});
			} else {
				console.error('没有数据渲染！');
				return;
			}
		},
		loadButton: function () {
			
		},
		loadScroll: function (op) {
			var self = this;
			var renderTarget = op.render;
			var pX, startY;
			var addY;
			
			var nScrollHight = 0; //滚动距离总长(注意不是滚动条的长度)
			var nScrollTop = 0;   //滚动到的当前位置
			var nDivHeight = jQuery('#' + renderTarget).height();
			
			var _render = jQuery('#' + renderTarget);
			
	        new $.iScroll(renderTarget,
				{
					hscroll: false,
					vscroll: true,
					hScrollbar:false, 
					vScrollbar:true,
					checkDOMChanges: true
				}
			);
		}
	};


	var approvallist = function () {
		return new ApprovalList(arguments);
	}; 
	$.cuiApprovallist = approvallist;
})(af, jQuery, window);