'use strict';
(function ($, jq, window, undefined) {
	var startTime = 0;
	var winW =  document.documentElement.clientWidth || document.body.clientWidth
	
	
	var createHtml = function (d, op, type) {
		// var editData = {
		// 			content: data.content,
		// 			size: data.size,
		// 			number: data.number,
		// 			sort: [],
		// 			lastPage: true,
		// 			firstPage: true,
		// 			totalElements: 4,
		// 			numberOfElements: 4,
		// 			totalPages: 1
		// 		};
		var id = op.id,
			data = d.content,
			dataFields = op.dataFields,
			liType = type || 'default',
			hasNext = d.next || false, 
			len = d.size || 20,
			nextHtml,
			html = '<div class="innerContainer" id="' + id +'"><div class="cui-suchivaList"><ul class="cui-suchivaList-ul">',

			//html = '<div class="innerContainer" id="' + id +'"><div class="total-comments">总计' + data.length+ '条评论</div><div class="cui-chatRoom"><ul class="cui-chatList">',
			width = $(window).width() - 60,
			boolenHtmlType = op.isHtmlType || false, //是否支持HTML字符
			lidom = addLi(data, boolenHtmlType, liType, op);
		if (dataFields.length > 0) {
			if (!hasNext) {
				if (typeof data !== 'undefined'  && data.length > 0) {
					nextHtml = '<div class="cui-suchivaList-nextContainer">没有更多了！</div>';
				} else {
					nextHtml = '';
				}
			} else {
				nextHtml = '<div class="cui-suchivaList-nextContainer "><a href="javascript:void(0);"  data-ignore="True" class="loadMoreItemToolbar">加载更多' + len + '项</a></div>';
			}
			html += lidom;
			html += '</ul>' + nextHtml +'</div></div>';
 
		} else if (data.length == 0 ){
			html += '</ul><div class="cui-suchivaList-noData">没有数据！</div></div></div>'	
		}
		return html; 
	};

	var addHtml = function (data, boolenHtmlType, liType, op) {
			var html = '',
				lidom = addLi(data, boolenHtmlType, liType, op);
			html = lidom;
			return html;

	};

	var addLi = function (data, boolenHtmlType, liType, op) {
		var html = '';
		var liTrue = boolenHtmlType;
		var content;
		html = 	liFactory.init(data, boolenHtmlType, liType, op);
		return html; 
	};
	var setLiWidth = function () {
		$.each($('.cui-chatList-item-r'), function (v, k) {
			$(k)[0].style.width = winW - 29 + 'px';  
		});
	};

	var liFactory = {
		setData : function (data, op) {
			var self = this,
				obj = [],
				dataAry = [],
				fnMap = new Map(),
				dataFields = op.dataFields;
			$.each(dataFields, function (k, v) { 
				if (typeof v.fn === 'function') {
					fnMap.put(v.dataField, v.fn);
				} 
				obj.push(v['dataField']);
				if (typeof v.type !== 'undefined') {
					self.keyIndex = v.dataField;
				}
			});
			
			//字段
			$.each(data, function (k, v) {
				var _obj = {};
				$.each(obj, function (l,j) {
					if (typeof fnMap.get(j) !== 'undefined') {
						_obj[j] = fnMap.get(j)(v);
					} else {
						_obj[j] = v[j];  
					}
				});
				dataAry.push(_obj);
			});
			self.store = dataAry;
		},
		getData : function () {
			return this.store;
		},
		init: function (data, boolenHtmlType, litype, op) {
			this.setData(data, op);
			this.op = op;
			var html = this.types[litype](this, boolenHtmlType);
			return html;
		}

	};						

	liFactory.types = {
		default : function (pointer, boolenHtmlType) {
			var html = '';
			var self = pointer;
			if (self.store.length > 0) {
				if (boolenHtmlType) {
					$.each(self.store, function (k, v) {
						//content = v.content; 
						var item = '<li>';
						for(var i in v) {
							var _div;
							v[i] = CTP.Util.ToHtmlString(v[i]);
							if (i === self.keyIndex) {
								_div = '<div class="suchivaList-li-div-' + i +'" style="display: none;"><a href="">' + v[i] +'</a></div>';
							} else {
								_div = '<div class="suchivaList-li-div-' + i +'"><a href="">' + v[i] +'</a></div>';
							}
							item += _div; 
						}
						item += '</li>';
						html += item;
					});
				} else {
					$.each(self.store, function (k, v) {
						var item = '<li>';
						for (var i in v) {
							item +='<div class="suchivaList-li-div-' + i +'"><a href="">' + v[i] +'</a></div>'
							
						}
						item += '<input class="li_value" type="hidden" data-key="2222" data-value="' + self.keyIndex +'" /></li>';
						html += item;
					});
				}
			} else  {
				html = '<div>暂时没有数据</div>';
			}
			return  html;
		},
		edit: function (pointer, boolenHtmlType) {
			var self = pointer,
				html = '';
			if (self.store.length > 0) {
				$.each(self.store, function (k, v) {
					var item = '<li>';
					for (var i in v) {
						v[i] = CTP.Util.ToHtmlString(v[i]);
						item += '<div class="suchivaList-li-div-' + i +'">编辑' + v[i] +'</div>'
					}
					item +='</li>';
					html += item;
				});
			} 
			return html;

		},
		link: function (pointer, boolenHtmlType) {
			var self = pointer,
				html = '',
				op = self.op;
			if (self.store.length > 0) {
				$.each(self.store, function (k, v) {
					var item = '<li style="position: relative;">';
					for (var i in v) {
						v[i] = CTP.Util.ToHtmlString(v[i]);
						var _div;
						if (i === self.keyIndex) { 
							_div = '<div class="suchivaList-li-div-' + i +'" style="display: none;">' + v[i] +'</div>';
						} else {
							_div = '<div class="suchivaList-li-div-' + i +'">' + v[i] +'</div>';
						}
						item += _div; 
					}
					
					item +='<div class="suchivaList-li-divLink ion-chevron-right" data-link="' + v[self.keyIndex] + '"><a  href="' + op.linkPage +'"></a></div></li>'
					html += item;
					console.log(item);
				});
			} 
			return html;
		},
		singleSelect: function (pointer,  boolenHtmlType) {
			var self = pointer,
				html = '';
			if (self.store.length > 0) {
				$.each(self.store, function (k, v) {
					
					var item = '<li style="position: relative;">';
					for (var i in v) {
						v[i] = CTP.Util.ToHtmlString(v[i]);
						if (i === self.keyIndex) {
							item += '<div class="suchivaList-li-div-' + i +'" style="display: none;">' + v[i] +'</div>'
						} else {
							item += '<div class="suchivaList-li-div-' + i +'">' + v[i] +'</div>'
						}
					}
					item +='<div class="suchivaList-li-divSingleSelect" data-value="' + v[self.keyIndex] + '" ><span></span></div></li>'
					html += item;
				});
			} 
			return html;
		},
		multipleSelect: function (pointer,  boolenHtmlType) {
			var self = pointer,
				html = '';
			if (self.store.length > 0) {
				$.each(self.store, function (k, v) {
					var item = '<li style="position: relative;">';
					for (var i in v) {
						v[i] = CTP.Util.ToHtmlString(v[i]);
						if (i === self.keyIndex) {
							item += '<div class="suchivaList-li-div-' + i +'" style="display: none;">' + v[i] +'</div>'
						} else {
							item += '<div class="suchivaList-li-div-' + i +'">' + v[i] +'</div>'
						}
					}
					item +='<div class="suchivaList-li-divMultipleSelect"  data-value="' + v[self.keyIndex] + '" ><span></span></div></li>'
					html += item;
				});
			} 
			return html;
		}
	};


	var List = function () {
		this.init.apply(this, arguments);
	};
	List.prototype = {
		constructor: List,
		init: function () {
			var args = Array.prototype.slice.apply(arguments)[0];
			var op = args[0],
				cb = args[1];
			this.options = op;
			this.cb = cb;
			this.setData(op);
			self.selectData = 0; 
			
		},
		render: function (data, op) {

			var self = this,
				renderTarget = op.render,
				type = op.type;
			var html = createHtml(data, op, type); 
			$('#' + renderTarget).html(html);
			self.setLiWidth();
			setTimeout(function () {
				self.loadScroll(op); 
			}, 200);
			$('#' + op.id).delegate('.loadMoreItemToolbar', 'click', function () {
				self.loadHistory(op);
			});
			if (op.type === 'singleSelect') {
				self.getSingleListData(op);
			}
			if (op.type === 'multipleSelect') {
				self.getMultipleListData(op);
			} 
			if (op.type === 'link') {
				self.goNext(op); 
			}
			if (typeof self.cb) {
				self.cb(self);
			}
		},
		goNext: function (op) {
			var self = this;
			var id = op.id;
			$('#' + id).delegate('.suchivaList-li-divLink', 'click', function () {
				var data = $(this).attr('data-link');
				self.linkData = data;
				self.cb(function () {
					return self.linkData;
				});
			});

		},
		getSingleListData: function (op) {
			var self = this;
			self.singleSelectData = {};
			$('#' + op.id).delegate('.suchivaList-li-divSingleSelect', 'click', function () {
				$('.suchivaList-li-divSingleSelect').find('span').removeClass('singleSelectBg');
				$(this).find('span').addClass('singleSelectBg');
				var data = $(this).attr('data-value');
				self.singleSelectData = data;
			});
			self.cb(self.singleSelectData);
		},
		getMultipleListData: function (op) {
			var self = this;
			self.mulitpleSelectData;
			$('#' + op.id).delegate('.suchivaList-li-divMultipleSelect', 'click', function () {
				var data = [];
				
				if ($(this).find('span').hasClass('multipleSelectBg')) {
					$(this).find('span').removeClass('multipleSelectBg');
				} else {
					$(this).find('span').addClass('multipleSelectBg');
				}
				var selectedItem = $('#' + op.id).find('.multipleSelectBg');
				$.each(selectedItem, function (k, v) {
					var _v = $(v).parent('div').attr('data-value');
					data.push(_v);
				});
				self.mulitpleSelectData = data;
			});
			self.cb(self.mulitpleSelectData);
			
		},
		addItem: function (data, cb) { 
			var op = this.options,
				id = op.id,
				boolenHtmlType = op.isHtmlType,
				liType = op.type,
				newHtml = addHtml(data, boolenHtmlType, liType, op);

			$('#' + id).find('.cui-chatList').prepend(newHtml);
			this.setLiWidth();
			var tempStr = '总计' + $('#' + id).find('.cui-chatList').children('li').length + '条评论';
			$('#' + id).find('.total-comments').html(tempStr); 
			if (typeof cb === 'function') {
				cb();
			}

		},
		setLiWidth: function () {
			setLiWidth();
		},
		addHistory: function (data, cb) {
			var op = this.options,
				id = op.id,
				boolenHtmlType = op.isHtmlType,
				liType = op.type,
				newHtml = addHtml(data, boolenHtmlType, liType, op);
				
			jq('#' + id).find('.cui-suchivaList-ul').slideDown('slow').append(newHtml)
			this.setLiWidth();
			var tempStr = '总计' + $('#' + id).find('.cui-suchivaList').children('li').length + '条评论';
			$('#' + id).find('.total-comments').html(tempStr);
			if (typeof cb === 'function') {
				cb();
			}
		},
		setData: function (op) {
			var self = this;
			if (typeof op.data !== 'undefined') {
				self.data = op.data;
				self.render(self.data, op);
			} else if (typeof op.adapter !== 'undefined') {
				self.data = op.adapter(function (d) {
					self.data = d;
					self.render(self.data, op);					
				});
			} else {
				console.error('没有数据渲染！');
				return;
			}
			

		},
		refresh: function (op) {
			var self = this;
			if(typeof op.refresh === 'function') {
				op.refresh(function (d, cb) {
					if (d.content.length > 0) {//有数据
						self.data = d;
						self.render(self.data, op);	
					} else { //没有数据
						
					}
				});
			}
		},
		loadHistory: function (op) {
			var self = this;
			if(typeof op.history === 'function') {
				op.history(function (d) {
					var html;
					if (d.content.length > 0) {
						self.addHistory(d.content, function () { //有数据
							if (d.next) {
								html = '<a href="javascript:void(0);"  data-ignore="True" class="loadMoreItemToolbar">加载更多20项</a>';
							} else { //没有历史数据
							    html = '<div class="cui-suchivaList-noMore">没有更多数据了</div>';
							}
							$('#' + op.id).find('.cui-suchivaList-nextContainer').html(html);
						});
					} else { //没有数据
					
					}
				});
			}
		},
		loadScroll: function (op) {
			var self = this;
			var renderTarget = op.render;
			var pX, startY;
			var addY;
	        new $.iScroll(renderTarget,
				{
					hscroll: false,
					vscroll: true,
					hScrollbar:false, 
					vScrollbar:true,
					checkDOMChanges: true,  
					onScrollStart: function () {
						startY = this.pointY;
						addY = 1;
						startTime ++;

					},
					onScrollMove: function () {
						pX = this.y;
						if (this.y > 0) {
							addY = addY + 0.03;
							if (addY < 1.25) {
								$('#title-container img').css({
									"-webkit-transform": "scale(" + addY+", " +addY+")",
									"-webkit-transition":"200ms linear"});
							} 

						} 

					},
					onBeforeScrollEnd: function () {
						CTP.Util.transformBox($('#title-container img'), 500);	
						addY = 1;				
					}, 
					onScrollEnd: function () {
						addY = 1;	
						if (startY > (this.wrapperHeight -100) && pX < 0) {
							self.loadHistory(op);
						}
						if (startY < 300 && pX > 0) {
							self.refresh(op);
						}

					}
				}
			);
		}
	};


	var list = function () {
		return new List(arguments);
	}; 
	$.cuiList = list;
})(af, jQuery, window);